require("single_item_count.jl")
require("item_pair_count.jl")
require("candidate_pair.jl")
result_file = "result.txt"
data_files = "data/kosarak.dat"
pairs_file = "pairs.txt"
candidate_file = "candidate.txt"

threshold = 2000
hash_type = "div_keys"
div_step = 10

println("threshold = ", threshold)
println("hash_type = ", hash_type)


#Single Item
@time item_count = single_item_count(result_file,data_files)

println("Initial single items = ",length(values(item_count)))
M_single = length(values(item_count))*2*4
M_single_pairs = length(values(item_count))*length(values(item_count))*4

for (item,count) in item_count
	if(count < threshold)
		delete!(item_count,item)
    end
end

fo=open(result_file,"w")
for (item,count) in item_count
	#println(item,"=",count)
	write(fo,"$(item)\t=\t$(count)\n")
end
close(fo)

println("Remaining single items = ",length(values(item_count)))
M_freqSingle = length(values(item_count))*2*4


#Pairs
@time pair_count = item_pair_count(item_count, data_files)
println("Initial pairs = ",length(values(pair_count)))
M_freqSingle_pairs = length(values(pair_count))*3*4


#Candidates
@time candidate_count = candidate_pair(item_count, hash_type, div_step, data_files)
println("Initial canditates = ",length(values(candidate_count)))
M_freqSingle_candidates = length(values(candidate_count))*2*4

for (hashKey,count) in candidate_count
    if(count < threshold)
        delete!(candidate_count,hashKey)
    end
end

fo=open(candidate_file,"w")
for (hashKey,count) in candidate_count
        #println(item,"=",count)
        write(fo,"$(hashKey)\t=\t$(count)\n")
end
close(fo)

println("Remaining canditates = ",length(values(candidate_count)))
M_freqSingle_freqCandidates = length(values(candidate_count))*2*4



for (pair,count) in pair_count
    if hash_type == "small_key"
        candidate_key = string( min(int(pair[1]), int(pair[2])) )
    end
                
    if hash_type == "large_key"
        candidate_key  = string( max(int(pair[1]), int(pair[2])) )
    end
                
    if hash_type == "sum_keys"
        candidate_key  = string( int(pair[1]) + int(pair[2]) )
    end
    
    if hash_type == "diff_keys"
        candidate_key  = string( abs( int(pair[1]) - int(pair[2]) ) )
    end
    if hash_type == "div_keys"
        minKey = string( int( min(int(pair[1]), int(pair[2])) /div_step ))
        maxKey = string( int( max(int(pair[1]), int(pair[2])) /div_step ))
        candidate_key = string( minKey, ",",  maxKey )
    end   
    if !haskey(candidate_count,candidate_key)
        delete!(pair_count,pair)
    end
end
println("Pairs from candidates = ", length(values(pair_count)))
M_freqSingle_freqCandidate_pairs = length(values(pair_count))*3*4


for (pair,count) in pair_count
    if(count < threshold)
        delete!(pair_count,pair)
    end
end

fo=open(pairs_file,"w")
for (pair,count) in pair_count
	#println(item,"=",count)
	write(fo,"$(pair[1])\t$(pair[2])\t=\t$(count)\n")
end
close(fo)

println("Final pairs = ",length(values(pair_count)))


println("# Memory Analysis #")
memory_all_pairs = 0
memory_single = 0
memory_single_candidate = 0

println("Step 1, Single item count : ", M_single, " bytes")
memory_all_pairs = M_single
memory_single = M_single
memory_single_candidate = M_single

println("#All possible pairs : ", M_single_pairs, " bytes")
memory_all_pairs = memory_all_pairs + M_single_pairs

println("Step 2, Frequent single item(FSI) :", M_freqSingle, " bytes")

println("Step 3, (Option 1) Pairs_FSI : ", M_freqSingle_pairs, " bytes")
memory_single = max(memory_single, M_freqSingle + M_freqSingle_pairs )

println("Step 3, (Option 2) Initial Candidates : ", M_freqSingle_candidates, " bytes")
memory_single_candidate = max(memory_single_candidate, M_freqSingle + M_freqSingle_candidates)

println("Step 4, (Option 2) Remaining Candidates : ", M_freqSingle_freqCandidates, " bytes")

println("Step 5,( Option 2) Pairs_FSI+Candidates : ", M_freqSingle_freqCandidate_pairs, " bytes")
memory_single_candidate = max(memory_single_candidate, M_freqSingle + M_freqSingle_freqCandidates + M_freqSingle_freqCandidate_pairs)

println("# Memory Summary #")
println("memory_all_pair : ", memory_all_pairs, " bytes")
println("memory_freqSingle : ", memory_single, " bytes")
println("memory_freqSingle_candidate : ", memory_single_candidate, " bytes")